import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A rocket that can be controlled by the arrowkeys: up, left, right.
 * The gun is fired by hitting the 'space' key. 'z' releases a proton wave.
 * 
 * @author Poul Henriksen
 * @author Michael Kolling
 * 
 * @version 1.0
 */
public class Broken_Rocket extends Animal
{
    private GreenfootImage rocket = new GreenfootImage("rocket.png");    
    private GreenfootImage rocketWithThrust = new GreenfootImage("rocketWithThrust.png");
    private static final int summonAsteriod = 100;        
    private int summonTimeAsteriod; 
    /**
     * Initilise this rocket.
     */
    public Broken_Rocket()
    {
        addForce(new Vector(5,0.3));
    }

    /**
     * Do what a rocket's gotta do. (Which is: mostly flying about, and turning,
     * accelerating and shooting when the right keys are pressed.)
     */
    public void act()
    {
        move();                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
        checkKeys();
        checkCollision();
        summonTimeAsteriod++;
        if (summonTimeAsteriod > summonAsteriod)
        {
            Space space = (Space) getWorld();
            getWorld().addObject(new Asteroid(),0, 0);
             getWorld().addObject(new Ultproton(),getX() - Greenfoot.getRandomNumber(900), getY() - Greenfoot.getRandomNumber(900));
            summonTimeAsteriod = 0;
        }
    }
    /**
     * Check whether there are any key pressed and react to them.
     */
    private void checkKeys() 
    {
        ignite(Greenfoot.isKeyDown("up"));
        if (Greenfoot.isKeyDown("left")) 
        {
            setRotation(getRotation() - 5 );
        }
        if (Greenfoot.isKeyDown("right")) 
        {
            setRotation(getRotation() + 5);
        }
    }
    private void ignite(boolean boosterOn)
    {
        if(boosterOn)
        {
//             setImage(rocketWithThrust);
            addForce(new Vector(getRotation(),0.3));
        }
        else
        {
            setImage(rocket);
        }
    }
      private void checkCollision()
    {
     Actor a =getOneIntersectingObject(Asteroid.class);
     Actor c =getOneIntersectingObject(EvilProtonWave.class);          
     Actor b =getOneIntersectingObject(EvilBullet.class);
     Actor d =getOneIntersectingObject(Evil_Explosion.class);
     Actor Ancient = getOneIntersectingObject(Ancient_Tech.class);
    if (a != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
     }
    if (c != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
     }
    if (b != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
    }
    if (d != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
    }
    if (Ancient != null)
    {
      Space space = (Space) getWorld();
      space.addObject( new ProtonWave(), getX(), getY());
      space.addObject(new Ultimate_Rocket(),getX(),getY());
      space.removeObject(this);
      space.removeObject(Ancient);
    }

     }

}