import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A rocket that can be controlled by the arrowkeys: up, left, right.
 * The gun is fired by hitting the 'space' key. 'z' releases a proton wave.
 * 
 * @author Poul Henriksen
 * @author Michael Kolling
 * 
 * @version 1.0
 */
public class Rocket2 extends Animal
{
    private static final int gunReloadTime = 5;         // The minimum delay between firing the gun.
    private int reloadDelayCount;    // How long ago we fired the gun the last time.
    private int protonReloadTime = 100;
    private int protonDelayCount;
    private GreenfootImage rocket = new GreenfootImage("rocket.png");    
    private GreenfootImage rocketWithThrust = new GreenfootImage("rocketWithThrust.png");
    int x = 0;
    int teleY = 0;
    int teleXZ = 0;
    int teleYZ = 0;
        int teleXYZ = 0;
    int teleYYZ = 0;
    int q = 0;
    /**
     * Initilise this rocket.
     */
    public Rocket2()
    {
        reloadDelayCount = 5;
        addForce(new Vector(5,0.3));
    }

    /**
     * Do what a rocket's gotta do. (Which is: mostly flying about, and turning,
     * accelerating and shooting when the right keys are pressed.)
     */
    public void act()
    {
        move();                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
        checkKeys();
        checkCollision();
        reloadDelayCount++;
        protonDelayCount++;
                if (x == 1)
        {
            teleporter();
        }
                        if (teleY == 1)
        {
            teleporter2();
        }
    }
    public void teleporter2()
    {
                                if (Greenfoot.isKeyDown("w") && teleY == 1)
        {
           Space space = (Space) getWorld();
           teleXZ = getX();
           teleYZ = getY();
          space.addObject( new Teleporter_Exit(),teleXZ, teleYZ);
          x = 0;
          teleY = 0;
        }
    }
    public void teleporter()
     {    
                if (Greenfoot.isKeyDown("q") && x == 1)
        {
           Space space = (Space) getWorld();
           teleXYZ = getX();
           teleYYZ = getY();
          space.addObject( new Teleporter(),teleXYZ, teleYYZ);
          x = 0;
          teleY = 1;
        }
    }
    private void checkKeys() 
    {
        ignite(Greenfoot.isKeyDown("up"));
        if (Greenfoot.isKeyDown("space")) 
        {
            fire();
        }
        if (Greenfoot.isKeyDown("left")) 
        {
            setRotation(getRotation() - 5 );
        }
        if (Greenfoot.isKeyDown("right")) 
        {
            setRotation(getRotation() + 5);
        }
        if (Greenfoot.isKeyDown("space")) 
        {
            fire();
        }
        if (Greenfoot.isKeyDown("z"))
        {
            startProtonWave();
        }
                if (Greenfoot.isKeyDown("a")) 
        {
            drone();
        }
    }
    private void ignite(boolean boosterOn)
    {
        if(boosterOn)
        {
//             setImage(rocketWithThrust);
            addForce(new Vector(getRotation(),0.3));
        }
        else
        {
            setImage(rocket);
        }
    }
    private void firetwo()
    {
        Bullet bullet = new Bullet (getMovement().copy(), getRotation());
         getWorld().addObject (bullet, getX() - 20, getY() - 20 );
               bullet.move ();
             firethree();
    }
    private void firethree()
    {
        Bullet bullet = new Bullet (getMovement().copy(), getRotation());
          getWorld().addObject (bullet, getX(), getY() );
           bullet.move ();
            reloadDelayCount = 0;
    }
      private void checkCollision()
    {
     Actor a =getOneIntersectingObject(Asteroid.class);
     Actor c =getOneIntersectingObject(EvilProtonWave.class);          
     Actor b =getOneIntersectingObject(EvilBullet.class);
     Actor d =getOneIntersectingObject(Evil_Explosion.class);
     Actor Ship_Upgrade = getOneIntersectingObject(Ship_Upgrade.class);
          Actor Teleporter_Powerup = getOneIntersectingObject(Teleporter_Powerup.class);
                    Actor Teleporter_Exit = getOneIntersectingObject(Teleporter_Exit.class);
                    Actor Teleporter = getOneIntersectingObject(Teleporter.class);
                    Actor Ancient = getOneIntersectingObject(Ancient_Tech.class);
    if (a != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
     }
    if (c != null && q != 1)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
     }
    if (b != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
    }
    if (d != null && q != 1)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.gameOver();
    }
        if (Ship_Upgrade != null)
     {
      Space space = (Space) getWorld();
        space.addObject( new Rocket3(), Greenfoot.getRandomNumber(getWorld().getWidth()), Greenfoot.getRandomNumber(getWorld().getHeight()));
      space.removeObject(Ship_Upgrade);
    

     }
                if (Teleporter_Powerup != null)
     {
         x = 1;
      Space space = (Space) getWorld();
      space.removeObject(Teleporter_Powerup);
     }
     if (Teleporter_Exit != null)
     {
         setLocation(teleXYZ + 60,teleYYZ + 60);
     }
          if (Teleporter != null)
     {
         setLocation(teleXZ -60,teleYZ-60);
     }
     if (Ancient != null)
     {
          Space space = (Space) getWorld();
      space.removeObject(Ancient);
         q = 1;
         protonReloadTime = 20;
         
        }
    }
    private void drone()
    {
        
        
        
     Drone drone = new Drone();
     getWorld().addObject(drone,getX(),getY());        
        
        
        
        
        
    }
    private void startProtonWave()
    {
     if(protonDelayCount >= protonReloadTime)
     {
     Ultproton wave = new Ultproton();
     getWorld().addObject(wave,getX(),getY());
      getWorld().addObject(wave,getX(),getY());
       getWorld().addObject(wave,getX(),getY());
     protonDelayCount=0;
     }
    }
        /**
     * Fire a bullet if the gun is ready.
     */
    private void fire() 
    {
        if (reloadDelayCount >= gunReloadTime) 
        {
            Bullet bullet = new Bullet (getMovement().copy(), getRotation());
            getWorld().addObject (bullet, getX() + 20, getY() + 20);
            bullet.move ();
            reloadDelayCount = 0;
            firetwo();
        }

}
}