import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A rocket that can be controlled by the arrowkeys: up, left, right.
 * The gun is fired by hitting the 'space' key. 'z' releases a proton wave.
 * 
 * @author Poul Henriksen
 * @author Michael Kolling
 * 
 * @version 1.0
 */
public class Rocket3 extends Animal
{
    private static final int gunReloadTime = 5;         // The minimum delay between firing the gun.
    private int reloadDelayCount;    // How long ago we fired the gun the last time.
    private static final int protonReloadTime = 100;
    private int protonDelayCount;
    private GreenfootImage rocket = new GreenfootImage("rocket.png");    
    private GreenfootImage rocketWithThrust = new GreenfootImage("rocketWithThrust.png");
    /**
     * Initilise this rocket.
     */
    public Rocket3()
    {
        reloadDelayCount = 5;
        addForce(new Vector(5,0.3));
    }

    /**
     * Do what a rocket's gotta do. (Which is: mostly flying about, and turning,
     * accelerating and shooting when the right keys are pressed.)
     */
    public void act()
    {
        move();                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
        checkKeys();
        checkCollision();
        reloadDelayCount++;
        protonDelayCount++;
        rocketcords();
    }
    public void rocketcords()
     {     }
    /**
     * Check whether there are any key pressed and react to them.
     */
    private void checkKeys() 
    {
        ignite(Greenfoot.isKeyDown("up"));
        if (Greenfoot.isKeyDown("space")) 
        {
            fire();
        }
        if (Greenfoot.isKeyDown("left")) 
        {
            setRotation(getRotation() - 5 );
        }
        if (Greenfoot.isKeyDown("right")) 
        {
            setRotation(getRotation() + 5);
        }
        if (Greenfoot.isKeyDown("space")) 
        {
            fire();
        }
        if (Greenfoot.isKeyDown("z"))
        {
            startProtonWave();
        }
    }
    private void ignite(boolean boosterOn)
    {
        if(boosterOn)
        {
//             setImage(rocketWithThrust);
            addForce(new Vector(getRotation(),0.3));
        }
        else
        {
            setImage(rocket);
        }
    }
    private void firetwo()
    {
        Bullet bullet = new Bullet (getMovement().copy(), getRotation());
         getWorld().addObject (bullet, getX() - 20, getY() - 20 );
               bullet.move ();
             firethree();
    }
    private void firethree()
    {
        Bullet bullet = new Bullet (getMovement().copy(), getRotation());
          getWorld().addObject (bullet, getX(), getY() );
           bullet.move ();
            reloadDelayCount = 0;
    }
      private void checkCollision()
    {
     Actor a =getOneIntersectingObject(Asteroid.class);
     Actor c =getOneIntersectingObject(EvilProtonWave.class);          
     Actor b =getOneIntersectingObject(EvilBullet.class);
     Actor d =getOneIntersectingObject(Evil_Explosion.class);
     Actor Ship_Upgrade = getOneIntersectingObject(Ship_Upgrade.class);
    if (a != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
     }
    if (c != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
     }
    if (b != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
    }
    if (d != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
    }
    }
    
    private void startProtonWave()
    {
     if(protonDelayCount >= protonReloadTime)
     {
     ProtonWave wave = new ProtonWave();
     getWorld().addObject(wave,getX(),getY());
     protonDelayCount=0;
     }
    }
        /**
     * Fire a bullet if the gun is ready.
     */
    private void fire() 
    {
        if (reloadDelayCount >= gunReloadTime) 
        {
            Bullet bullet = new Bullet (getMovement().copy(), getRotation());
            getWorld().addObject (bullet, getX() + 20, getY() + 20);
            bullet.move ();
            reloadDelayCount = 0;
            firetwo();
        }

}
}