import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A rocket that can be controlled by the arrowkeys: up, left, right.
 * The gun is fired by hitting the 'space' key. 'z' releases a proton wave.
 * 
 * @author Poul Henriksen
 * @author Michael Kolling
 * 
 * @version 1.0
 */
public class Sd extends SmoothMover
{
    private static final int gunReloadTime = 5;         // The minimum delay between firing the gun.
    private int reloadDelayCount;    // How long ago we fired the gun the last time.
    private static final int turnReloadTime = 50;
    private int turnDelayCount ;
    private GreenfootImage rocket = new GreenfootImage("rocket.png");    
    private GreenfootImage rocketWithThrust = new GreenfootImage("rocketWithThrust.png");

    /**
     * Initilise this rocket.
     */
    public Sd()
    {
        reloadDelayCount = 5;
        addForce(new Vector(5,0.3));
    }

    /**
     * Do what a rocket's gotta do. (Which is: mostly flying about, and turning,
     * accelerating and shooting when the right keys are pressed.)
     */
    public void act()
    {
        move(3);
         turnTime();
            fire();
             turnDelayCount++;
             checkCollision();
    }
         private void turnTime()
    {
     if(turnDelayCount >= turnReloadTime)
     {
         turn(Greenfoot.getRandomNumber(360));
      turnDelayCount=0;
     }
    }
    private void ignite(boolean boosterOn)
    {
        if(Greenfoot.getRandomNumber(1000) <950)
        {
            setImage(rocketWithThrust);
            addForce(new Vector(getRotation(),0.3));
        }
        else
        {
            setImage(rocket);
        }
    }
    
    /**
     * Fire a bullet if the gun is ready.
     */
    private void fire() 
    {
        if (Greenfoot.getRandomNumber(1000) > 940) 
        {
            EvilBullet evilbullet = new EvilBullet (getMovement().copy(), getRotation());
            getWorld().addObject (evilbullet, getX(), getY());
            evilbullet.move ();
            reloadDelayCount = 0;
        }
    }
    
      private void checkCollision()
    {
      Actor a =getOneIntersectingObject(Bullet.class);
      Actor b =getOneIntersectingObject(ProtonWave.class);
       Actor c =getOneIntersectingObject(Evil_Explosion.class);
                Actor e =getOneIntersectingObject(Proton_Wall.class);
    if (a != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
                 EvilProtonWave wave = new EvilProtonWave();
     getWorld().addObject(wave,getX(),getY());
      space.removeObject(this);
      space.countScore(25);
     }
         if (c != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
        EvilProtonWave wave = new EvilProtonWave();
     getWorld().addObject(wave,getX(),getY());
      space.removeObject(this);
      space.countScore(25);
     }
      if (b != null)
     {
      Space space = (Space) getWorld();
      space.addObject( new Explosion(), getX(), getY());
      space.removeObject(this);
      space.countScore(25);
           ProtonWave wave = new ProtonWave();
     getWorld().addObject(wave,getX(),getY());
    }

    if (e != null)
     {
      Space space = (Space) getWorld();
      space.removeObject(this);
       space.countScore(25);
     }
    }
}