import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;

/**
 * Space. Something for rockets to fly in.
 * 
 * @author Michael Kolling
 * @version 1.0
 */
public class Space extends World
{
    private Counter scoreCounter;
    private int startAsteroids = 2;
    private static final int spawnReloadTime = 3000;
    private int spawnDelayCount ;
    private static final int spawReloadTime = 500;
    private int spawDelayCount ;
    private static final int spawn1ReloadTime = 1800;
    private int spawn1DelayCount ;
    private static final int spawn2ReloadTime = 2500;
    private int spawn2DelayCount ;
    private int spawn3ReloadTime = 2000;
    private int spawn3DelayCount ;
    private int spawnAsteriodTime = 3000;
    private int spawnAsteriod;
    private int spawnSpawnT1ime = 0;
    private int spawnSelect;
    public Space() 
    {
        super(800, 860, 1);
        GreenfootImage background = getBackground();
        background.setColor(Color.BLACK);
        background.fill();

        createStars(500);

        addAsteroids(startAsteroids);

        scoreCounter = new Counter("Score: ");
        addObject(scoreCounter, 60, 380);

        Explosion.initializeImages();
        ProtonWave.initializeImages();
    }

    private void turnTime()
    {
        if(spawnDelayCount >= spawnReloadTime)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Sd(), x, y);
            spawnDelayCount = 0;
        }     if(spawDelayCount >= spawReloadTime)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Bomb_powerup(), x, y);
              x = Greenfoot.getRandomNumber(getWidth());
              y = Greenfoot.getRandomNumber(getHeight());
            addObject(new QED_Powerup(), x, y);
            spawDelayCount = 0;
        }
        if(spawn1DelayCount >= spawn1ReloadTime)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Proton_Wall_Powerup(), x, y);
            spawn1DelayCount = 0;
 x = Greenfoot.getRandomNumber(getWidth());
 y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Asteroid(), x, y);
        }
        if(spawn2DelayCount >= spawn2ReloadTime)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Ship_Upgrade(), x, y);
            addObject(new Space_Strike_Powerup(), x, y);
            spawn2DelayCount = 0;
        }
        if(spawn3DelayCount >= spawn3ReloadTime)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Teleporter_Powerup(), x, y);
            spawn3DelayCount = 0;
            spawn3ReloadTime = 2147483647;
        }
        if(spawnAsteriod >= spawnAsteriodTime)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Squid(), x, y);
            spawnAsteriod = 0;
            spawnAsteriodTime = 3200;
        }
    }

    public void act()
    {
        turnTime();
        spawnDelayCount++;
        spawDelayCount++;
        spawn1DelayCount++;
        spawn2DelayCount++;
        spawn3DelayCount++;
        spawnAsteriod++;
                if (Greenfoot.isKeyDown("2") && spawnSelect >= spawnSpawnT1ime )
        {
            addObject(new Rocket(), 300, 400);
            spawnSelect = -123;
        }
                if (Greenfoot.isKeyDown("3") && spawnSelect >= spawnSpawnT1ime)
        {
            addObject(new Juggernaut(), 300, 400);
             spawnSelect = -123;
        }
                if (Greenfoot.isKeyDown("4" ) && spawnSelect >= spawnSpawnT1ime)
        {
            addObject(new Broken_Rocket(), 300, 400);
             spawnSelect = -123;
        }
        
        
      
    }

    private void createStars(int number)
    {
        GreenfootImage background = getBackground();
        for(int i = 0; i < number; i++)
        {
            int color = Greenfoot.getRandomNumber(256);
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            background.setColor(new Color(color,color,color));
            background.fillOval(x,y,3,3);
        }  
    }

    /**
     * Add a given number of asteroids to our world. Asteroids are only added into
     * the left half of the world.
     */
    private void addAsteroids(int count) 
    {
        for(int i = 0; i < count; i++) 
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(new Asteroid(), x, y);
        }
    }

    public void countScore(int count)
    {
        scoreCounter.add(count);
    }

    /**
     * This method is called when the game is over to display the final score.
     */
    public void gameOver() 
    {
        int finalScore = scoreCounter.getValue();
        ScoreBoard sb = new ScoreBoard(finalScore);
        addObject(sb, getWidth() / 2, getHeight() / 2);
        removeObjects(getObjects(Bullet.class));  
    }
/*
The Final Update:

2 New ships have been added and a whole bunch of powerups.

Powerups:
QED Powerup:
A randomspawn that can clear an entire section of the screen

Space_Strike:
Summons A Vertical Line of Rockets to wipe the screen.

Ancient Tech:
This tech will allow you to upgrade your ship to its unlimited potential.

Ships:
Juggeranut: Tankier and shoots much more than the standard Rocket but does not have proton wave.
Ships Upgrade: Gains More Hitpoints

Broken_Rocket:
This Rocket can not shoot or send proton waves but it becomes the ultimate rocket. There is random protonwaves on the screen.

Ultimate Rocket:
Ships Upgrade: Summon 1 Juggernaut and 1 Rocket.
Getting a Second Ancient_Tech allows you to summon a drone to that is industrictble is followed by a trail of bullets.
Is a combination of Rocket and Juggernaut.

Juggernaut Ancient Tech Upgrade: More Hits and Bullets

Rocket: Proton Wave now removes asteriods without spawning more and can spam it faster.

Squid:
Summons Asteriods and Bombs. Takes multiple hits but drops the Ancient Tech.

Controls:
Press
2: For Rocket
3: For Juggernaut
4: For Broken Rocket

Broken Rocket:
Arrow Keys Only

Ultimate Rocket Controls:
X is to Summon Drone
Z is Proton
Q & W: Teleporter
*/
}